package org.zipcoder.store;

import org.junit.Assert;
import org.junit.Test;

public class TriangleTeset {

    @Test
    public void one(){
        Assert.assertEquals("*\n", triangle(1));
    }

    @Test
    public void three(){
        Assert.assertEquals(" *\n***\n", triangle(3));
    }

    @Test
    public void five(){
        Assert.assertEquals("  *\n ***\n*****\n", triangle(5));
    }

    @Test
    public void seven(){
        Assert.assertEquals("   *\n  ***\n *****\n*******\n", triangle(7));
    }

    private String triangle(int number) {
        StringBuilder builder = new StringBuilder();

        int star = 1;
        int space = number/2;

        while(star <= number) {
            add(builder, ' ', space);
            add(builder, '*', star);
            builder.append('\n');
            star += 2;
            space -= 1;
        }

        return builder.toString();
    }

    private void add(StringBuilder builder, char value, int numberOfTimes) {
        for (int i = 0; i < numberOfTimes; i++) {
            builder.append(value);
        }
    }
}
